import numpy as np



def csa(matrix, alpha, use_delta):
    n = len(matrix)
    if use_delta:
        delta = 0
        for l in range(1, n + 1):
            delta += l-alpha
    else:
        delta = 1
    out = 0
    for l in range(1, n + 1):
        current = 1/(l-alpha)
        out += current * matrix[l-1]
    return delta * out


def csa_encoding(matrix, use_delta, worldSize):
    n = len(matrix)
    result = []
    # Tuple that returns the shape EG (4,4)
    size = matrix[0].shape
    # use_delta if this is matrix A
    # Distributed number
    for alpha in range(n + 1, worldSize + n):
        # build a f of zeros of size S
        f = np.zeros((size[0], size[1]))
        f += csa(matrix, alpha, use_delta)
        result.append(f)
    return result


# tester
def creator():
    # Create A and B Matrices
    # n=int(sys.argv[1])
    n = 6
    # d size=[int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
    size = (3, 2, 2)
    A = []
    B = []
    '''
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    '''
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(n):
        A.append(np.copy(rand_A))
    for i in range(n):
        B.append(np.copy(rand_B))

    # True if it is matrix A
    # print(A)
    A_CSA = csa_encoding(A, True, worldSize)
    # print(A_CSA)
    # print(B)
    B_csa = csa_encoding(B, False, worldSize)
    # print(B_csa)


# creator()
