import numpy as np
import time

def EP_encodeA(matrix, permutation, degree, f, h, g, worldSize):   ##we don't have permutation now!!!we can only encode one matrix
    S = matrix[0].shape
    Ap = []
    res = []
    n = len(permutation)
    c = worldSize
    for x in range(1, worldSize):
        res = np.zeros((S[0] // f, S[1] // h))
        for k in range(n):
            for i in range(1, f + 1):
                for j in range(1, h + 1):
                    res += matrix[permutation[k] - 1][((i - 1) * S[0] // f): (i * S[0] // f), ((j - 1) * S[1] // h): (j * S[1] // h)] * (float(x / c) ** (j - 1 + (i - 1) * g * h + f * g * h * degree[k]))
        Ap.append(res)

    return Ap

def EP_encodeB(matrix, permutation, degree, f, h, g, worldSize):   ##we don't have permutation now!!!we can only encode one matrix
    S = matrix[0].shape
    Bp = []
    res = []
    n = len(permutation)
    c = worldSize
    for x in range(1, worldSize):
        res = np.zeros((S[0] // h, S[1] // g))
        for k in range(n):
            for i in range(1, g + 1):
                for j in range(1, h + 1):
                    res += matrix[permutation[k] - 1][((j - 1) * S[0] // h): (j * S[0] // h), ((i - 1) * S[1] // g): (i * S[1] // g)] * (float(x / c) ** (h + 1 - j + (i - 1) * h + f * g * h * degree[k]))
        Bp.append(res)

    return Bp

def EP_encodeA_decentralized(matrix, permutation, degree, f, h, g, worldSize, rank):   ##we don't have permutation now!!!we can only encode one matrix
    S = matrix[0].shape
    # Ap = []
    res = []
    n = len(permutation)
    c = worldSize 
    x = rank
    
    res = np.zeros((S[0] // f, S[1] // h))
    for k in range(n):
        for i in range(1, f + 1):
            for j in range(1, h + 1):
                res += matrix[permutation[k] - 1][((i - 1) * S[0] // f): (i * S[0] // f), ((j - 1) * S[1] // h): (j * S[1] // h)] * (float(x / c) ** (j - 1 + (i - 1) * g * h + f * g * h * degree[k]))
    # Ap.append(res)
    return res

def EP_encodeB_decentralized(matrix, permutation, degree, f, h, g, worldSize, rank):   ##we don't have permutation now!!!we can only encode one matrix
    S = matrix[0].shape
    # Bp = []
    res = []
    n = len(permutation)
    c = worldSize 
    x = rank
    
    res = np.zeros((S[0] // h, S[1] // g))
    for k in range(n):
        for i in range(1, g + 1):
            for j in range(1, h + 1):
                res += matrix[permutation[k] - 1][((j - 1) * S[0] // h): (j * S[0] // h), ((i - 1) * S[1] // g): (i * S[1] // g)] * (float(x / c) ** (h + 1 - j + (i - 1) * h + f * g * h * degree[k]))
    # Bp.append(res)

    return res

def EP_decode(R, true_rows, index):
    threshold = len(index)
    M = np.ones((threshold, threshold))
    for i in range(0, threshold):
        for j in range(0, threshold):
            M[i, j] = float(index[i]) ** (j)
    R = np.reshape(R, (threshold, -1))
    M = np.linalg.pinv(M)
    M = M[true_rows, :]
    return np.dot(M, R)

# A = []
# A.append(np.ones((2, 3)))
# A.append(np.ones((2, 3)))
# B = []
# B.append(np.ones((3, 2)))
# B.append(np.ones((3, 2)))

# print(EP_encodeA(A, [1, 2], [0, 1], 2, 3, 2, 38))
# print(EP_encodeB(B, [1, 2], [0, 1], 2, 3, 2, 38))