import numpy as np
def GCSA_A(A, m, p, n, worldSize):
    #k = n
    R = m * p * n
    K = len(A)
    S = A[0].shape
    zero_P = np.zeros((S[0] // m, S[1] // p))
    Ap = []

    for a_s in range(worldSize):
        delta_a_s = 1
        P = []
        for i in range(K):
            P.append(np.copy(zero_P))
        for k in range(worldSize, worldSize + K):
            delta_a_s *= (k - a_s) ** R

        for k in range(worldSize, worldSize + K):
            for i in range(1, m + 1):
                for j in range(1, p + 1):
                    P[k - worldSize] += A[k - worldSize][((i - 1) * S[0] // m): (i * S[0] // m), ((j - 1) * S[1] // p): (j * S[1] // p)] * ( (k - a_s) ** (j - 1 + p *(i - 1) ))
     
        Psize = P[0].shape
        right = np.zeros((Psize[0], Psize[1]))
        for k in range(worldSize, worldSize + K):
            right += (1 / ((k - a_s) ** R) )* P[k - worldSize] 

        
        Ap.append(delta_a_s * right)
         
    return Ap



def GCSA_B(B, m, p, n, worldSize):
    R = m * p * n
    K = len(B)
    S = B[0].shape
    zero_Q = np.zeros((S[0] // p, S[1] // n))
    Bp = []

    for a_s in range(worldSize):
        Q = []
        for i in range(K):
            Q.append(np.copy(zero_Q))
        
        for k in range(worldSize, worldSize + K):
            for i in range(1, p + 1):
                for j in range(1, n + 1):
                    Q[k - worldSize] += B[k - worldSize][((i - 1) * S[0] // p): (i * S[0] // p), ((j - 1) * S[1] // n): (j * S[1] // n)] * ( (k - a_s) ** (p - i + p * m *(j - 1) ))
     
        Psize = Q[0].shape
        right = np.zeros((Psize[0], Psize[1]))
        for k in range(worldSize, worldSize + K):
            right += (1 / ((k - a_s) ** R) )* Q[k - worldSize] 

        Bp.append(right)
         
    return Bp


def GCSA_A_decentralized(A, m, p, n, worldSize, rank):
    #k = n
    R = m * p * n
    K = len(A)
    S = A[0].shape
    zero_P = np.zeros((S[0] // m, S[1] // p))
    # Ap = []
    a_s = rank
    c = worldSize + K

    delta_a_s = 1
    P = []
    for i in range(K):
        P.append(np.copy(zero_P))
    for k in range(worldSize, worldSize + K):
        delta_a_s *= ((k - a_s) / c) ** R

    for k in range(worldSize, worldSize + K):
        for i in range(1, m + 1):
            for j in range(1, p + 1):
                P[k - worldSize] += A[k - worldSize][((i - 1) * S[0] // m): (i * S[0] // m), ((j - 1) * S[1] // p): (j * S[1] // p)] * ( ((k - a_s) / c)  ** (j - 1 + p *(i - 1) ))
 
    Psize = P[0].shape
    right = np.zeros((Psize[0], Psize[1]))
    for k in range(worldSize, worldSize + K):
        right += (1 / (((k - a_s) / c) ** R) )* P[k - worldSize] 

    # Ap.append(delta_a_s * right)     
    return delta_a_s * right

def GCSA_B_decentralized(B, m, p, n, worldSize, rank):
    R = m * p * n
    K = len(B)
    S = B[0].shape
    zero_Q = np.zeros((S[0] // p, S[1] // n))
    # Bp = []
    a_s = rank
    c = worldSize + K
    
    Q = []
    for i in range(K):
        Q.append(np.copy(zero_Q))
    
    for k in range(worldSize, worldSize + K):
        for i in range(1, p + 1):
            for j in range(1, n + 1):
                Q[k - worldSize] += B[k - worldSize][((i - 1) * S[0] // p): (i * S[0] // p), ((j - 1) * S[1] // n): (j * S[1] // n)] * ( ((k - a_s) / c) ** (p - i + p * m *(j - 1) ))
 
    Psize = Q[0].shape
    right = np.zeros((Psize[0], Psize[1]))
    for k in range(worldSize, worldSize + K):
        right += (1 / (((k - a_s) / c) ** R) )* Q[k - worldSize] 

    # Bp.append(right)
         
    return right


# tester
def creator():
    # Create A and B Matrices
    # n=int(sys.argv[1])
    k = 6
    # d size=[int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
    size = (4, 4, 4)
    A = []
    B = []
    worldSize = 3
    '''
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    '''
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(worldSize):
        A.append(np.copy(rand_A))
    for i in range(worldSize):
        B.append(np.copy(rand_B))

    # True if it is matrix A
    # print(A)
    print(GCSA_B(B, 4, 4, 4, worldSize))
    # print(A_CSA)
    # print(B)
    # B_csa =  GCSA(matrix, m, p, n, worldSize, "B")
    # print(B_csa)


#creator()
