import numpy as np
from lagrange import *
def GEP_A(matrix, m, p, n, worldSize):
    S = matrix[0].shape
    Ap = []
    res = []
    K = len(matrix)
    c = worldSize
    for x in range(1, worldSize):
        for k in range(K):
            res = np.zeros((S[0] // m, S[1] // p))
            for i in range(1, m + 1):
                for j in range(1, p + 1):
                    res += matrix[k][((i - 1) * S[0] // m): (i * S[0] // m), ((j - 1) * S[1] // p): (j * S[1] // p)] * (float(x / c) ** (j + i * p))
        Ap.append(res)
    return lagrange_coding(Ap, worldSize)


def GEP_B(matrix, m, p, n, worldSize):
    S = matrix[0].shape
    Bp = []
    res = []
    K = len(matrix)
    c = worldSize
    for x in range(1, worldSize):
        for k in range(K):
            res = np.zeros((S[0] // p, S[1] // n))
            for i in range(1, n + 1):
                for j in range(1, p + 1):
                    res += matrix[k][((j - 1) * S[0] // p): (j * S[0] // p), ((i - 1) * S[1] // n): (i * S[1] // n)] * (float(x / c) ** (p - 1 - j + i * p * m) )
        Bp.append(res)
    return lagrange_coding(Bp, worldSize)

    
def GEP_A_decentralized(matrix, m, p, n, worldSize, rank):
    S = matrix[0].shape
    Ap = []
    res = []
    K = len(matrix)
    c = worldSize
    x = rank
    
    res = np.zeros((S[0] // m, S[1] // p))
    for k in range(K):
        for i in range(1, m + 1):
            for j in range(1, p + 1):
                res += matrix[k][((i - 1) * S[0] // m): (i * S[0] // m), ((j - 1) * S[1] // p): (j * S[1] // p)] * (float(x / c) ** (j + i * p))
    Ap.append(res)
    return lagrange_decentralized_coding(Ap, K * (m * p * n + m - 1), rank)
    # return lagrange_coding(Ap, 2)

     

def GEP_B_decentralized(matrix, m, p, n, worldSize, rank):
    S = matrix[0].shape
    Bp = []
    res = []
    K = len(matrix)
    c = worldSize
    x = rank
    
    res = np.zeros((S[0] // p, S[1] // n))
    for k in range(K):
        for i in range(1, n + 1):
            for j in range(1, p + 1):
                res += matrix[k][((j - 1) * S[0] // p): (j * S[0] // p), ((i - 1) * S[1] // n): (i * S[1] // n)] * (float(x / c) ** (p - 1 - j + i * p * m) )
    Bp.append(res)
    return lagrange_decentralized_coding(Bp, K * (m * p * n + m - 1), rank)

      
# tester
def creator():
    # Create A and B Matrices
    # n=int(sys.argv[1])
    k = 6
    # d size=[int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
    size = (4, 4, 4)
    A = []
    B = []
    worldSize = 3
    '''
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    '''
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(worldSize):
        A.append(np.copy(rand_A))
    for i in range(worldSize):
        B.append(np.copy(rand_B))

    # True if it is matrix A
    # print(A)
    print(GEP_A(A, 4, 4, 4, worldSize))
    # print(A_CSA)
    # print(B)
    # B_csa =  GCSA(matrix, m, p, n, worldSize, "B")
    # print(B_csa)



