#!/usr/bin/env python
from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map import *
from GEP import *


comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0


R = []
for i in range(worldSize + 1):
    R.insert(i,"")
c = 35.0

n = int(sys.argv[1])
f = int(sys.argv[2])
h = int(sys.argv[3])
g = int(sys.argv[4])
size = [int(sys.argv[5]), int(sys.argv[6]), int(sys.argv[7])]

if rank != TaskMaster:
    #f = m, h = p, g = n in the paper

    if size[0] % f != 0 or size[1] % h != 0 or size[2] % g != 0:
        print("size input incorrect")
        exit(0)

    A = []
    B = []
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
        
    comm.barrier()
    Ap = GEP_A_decentralized(A, f, h, g, worldSize, rank)
    Bp = GEP_B_decentralized(B, f, h, g, worldSize, rank)
    comm.barrier()
    exit(0)

if rank == TaskMaster:
    result = []
    threshold = 2 * n - 1                              #threshold needs to change!!
    comm.barrier()
    start = time.time()
    # while(len(result) < threshold):
    #     st = MPI.Status()
    #     comm.Probe(status=st)
    #     i = st.source
    #     result.append(comm.recv(source=i, tag=0))
    comm.barrier()
    end = time.time()
    print(float(end - start))
