from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map_new_scheme import *
from GEP import *

comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0
c = 35.0

n = int(sys.argv[1])
f = int(sys.argv[2])
h = int(sys.argv[3])
g = int(sys.argv[4])
size = [int(sys.argv[5]), int(sys.argv[6]), int(sys.argv[7])]


if rank != TaskMaster:
    #f = m, h = p, g = n in the paper
    if size[0] % f != 0 or size[1] % h != 0 or size[2] % g != 0:
        print("size input incorrect")
        exit(0)
    comm.barrier()
    A = []
    B = []
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    
    Ap = GEP_A_decentralized(A, f, h, g, worldSize, rank)
    Bp = GEP_B_decentralized(B, f, h, g, worldSize, rank)
    # print(Ap)
    # print(Bp)
    comm.barrier()
    ABp = np.dot(Ap, Bp)
    request = comm.send(ABp, dest=TaskMaster, tag=0)
    exit()


if rank == TaskMaster:
    indexAB = []
    Data = []
    ABp = []
    for i in range(worldSize - 1):
        ABp.insert(i, "")
    threshold = 2 * n * (f * h * g + g - 1) - 1
    comm.barrier()
    start = time.time()
    comm.barrier()
    print_time(start)
    start = time.time()
    while(len(indexAB) < threshold):
        st = MPI.Status()
        comm.Probe(tag=0, status = st)
        i = st.source
        data = comm.recv(source = i, tag= 0)
        ABp.insert(i - 1, data)
        del ABp[i]
        indexAB.append(i)
    indexAB.sort()
    print_time(start)
    start = time.time()
    AB = Numpy_decode(ABp, indexAB, [size[0], size[1]], f, h, g, threshold, worldSize) #we use Rook because the c in x / c is still worldsize 
    end = time.time()
    print_time(start)

