from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map_new_scheme import *
from Entangled_Polynomial import *

comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0
c = 35.0

n = int(sys.argv[1])
f = int(sys.argv[2])
h = int(sys.argv[3])
g = int(sys.argv[4])
size = [int(sys.argv[5]), int(sys.argv[6]), int(sys.argv[7])]
M = [i for i in range(1, n + 1)]
N, P, Q = createNPQ(n)

if rank != TaskMaster:
    if size[0] % f != 0 or size[1] % h != 0 or size[2] % g != 0:
        print("size input incorrect")
        exit(0)
    Ap, Bp = comm.recv(source=TaskMaster, tag=100)
    ABp = np.dot(Ap, Bp)
    request = comm.send(ABp, dest=TaskMaster, tag=0)
    exit()

if rank == TaskMaster:
    indexAB = []
    Data = []
    ABp = []
    for i in range(worldSize - 1):
        ABp.insert(i, "")
    threshold = (P[-1] + Q[-1] + 1) * f * g * h + h - 1
    A = []
    B = []
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    start = time.time()
    for worker_num in range(1, worldSize):
        Ap = EP_encodeA_decentralized(A, M, P, f, h, g, worldSize, worker_num)
        Bp = EP_encodeB_decentralized(B, N, Q, f, h, g, worldSize, worker_num)
        # comm.send([Ap, Bp], dest=worker_num, tag=100)
    print_time(start)
    # start = time.time()
    # while(len(indexAB) < threshold):
    #     st = MPI.Status()
    #     comm.Probe(tag=0, status = st)
    #     i = st.source
    #     data = comm.recv(source = i, tag= 0)
    #     ABp.insert(i - 1, data)
    #     del ABp[i]
    #     indexAB.append(i)
    # indexAB.sort()
    # print_time(start)
    # start = time.time()
    # AB = Numpy_decode(ABp, indexAB, [size[0], size[1]], f, h, g, threshold, worldSize) #1,1, 1 is m, p, n
    # end = time.time()
    # print_time(start)

