import time
import numpy as np


def print_time(start):
    end = time.time()
    print(float(end - start))

def power_two_test(k):
	i = 1
	while i <= k:
		i *=2	
	if i == k:
		return True
	else:
		return False

def r_col(i,n):
	if i > n:
		return 0
	elif i == 1:
		return n 
	elif i <= n//2:
		return 2*r_col(i,n//2)
	elif i<= n:
		return r_col(i-n//2,n//2) 
	else:
		return 0

def r(i,n):
	if i > n:
		return 0
	if i == 1:
		return 1
	elif i <= n//2:
		return r(i,n//2)
	elif i<= n:
		return r_col(i-n//2,n//2) + r(i-n//2,n//2)

def true_rec(k):
	if power_two_test(k) == True:
		return int(3**math.log2(k))		
	n = 1
	p = 1
	while n <= k:
		n = 2*n	
		p *= 3
	m = p//3
	for i in range(n//2,k):
		m += r(i+1,n)
	return m	

#A is an array of P X R matrices and B is a array of R X Q matrices
#n is the number of matrices in A and B (i.e., the batch size)
#k is the number of workers, points is where we evaluate the polynomials
#degrees is the degrees of the non-zero coeffcients in the Rook code poly
def rook_mat_encode(A,B,points,degrees,n,k,P,Q,R):
	G_A = np.empty([k, n])
	G_B = np.empty([k, n])
	for w, p in enumerate(points):
		for i in range(n):
			G_A[w][i] = p**degrees[i]
			G_B[w][i] = p**degrees[i]
	EA  = np.empty([k, P, R])
	EB  = np.empty([k, R, Q])
	for i in range(k):
		EA[i] = np.einsum('n,npr->pr', G_A[i], A)
		EB[i] = np.einsum('n,nrq->rq', G_B[i], B)
	return EA, EB

#returns the exponent for the rook code for n=1..6
def degrees(n):
	exponents = [0, 1, 3, 4, 9, 10]
	return exponents[:n]
	

def honerPolinomial(matrix, permunation, degree, rank, worldSize):
	S = matrix[0].shape
	n = len(degree)
	c = worldSize
	matrixP = np.zeros((S[0], S[1]))
	for i in range(n - 1, 0, -1):
		matrixP =  (matrix[i]+ matrixP) * (float(int(rank) / c) ** (degree[i] - degree[i - 1]))
	matrixP = matrix[0] + matrixP
	return matrixP
	#for i in range(degree[-1], -1, -1):
		# if i in degree:
		# 	if degree.index(i) > 0:
		# 		matrixP =  (matrix[degree.index(i)]+ matrixP) * (float(int(rank) / c))
		# 	elif degree.index(i) == 0:
		# 		matrixP = matrix[0] + matrixP
		# else:
		# 	matrixP *= (float(int(rank) / c))

def matrix_prod(M):
    m = len(M)
    R = M[0]
    for i in range(1, m):
        R = np.dot(R,  M[i])
    return R


def Numpy_decode(R, index, ShapeA, m, p, n, threshold, worldSize):
	result = []
	for j in index:   
		result.append(R[int(j) - 1])
	result = np.reshape(result, (threshold, -1))
	P = [m, p, n]
	# M = np.ones((threshold, threshold), dtype=np.float16)
	M = np.ones((threshold, threshold), dtype=np.float32)
	for i in range(len(index)):
		for j in range(0, threshold):
			M[i - 1, j] = float(index[i] / worldSize) ** (j)

	M = np.linalg.pinv(M)
	#M = M[: ,rows ]
	result = np.dot(M, result)
	
	return result

def Numpy_decode_n_5_6(R, index, ShapeA, m, p, n, threshold, worldSize, numMatrices):
        result = []
        if numMatrices == 5:
            exponents = [0,1,2,3,4,5,6,7,8,9,10,12,13,18]
        if numMatrices == 6:
            exponents = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 18, 19, 20 ] 
        for j in index:
                result.append(R[int(j) - 1])
        result = np.reshape(result, (threshold, -1))
        P = [m, p, n]
        # M = np.ones((threshold, threshold), dtype=np.float16)
        M = np.ones((threshold, threshold), dtype=np.float32)
        for i in range(len(index)):
                for j in range(0, threshold):
                        M[i - 1, j] = float(index[i] / worldSize) ** exponents[j]

        M = np.linalg.pinv(M)
        #M = M[: ,rows ]
        result = np.dot(M, result)

        return result

def Numpy_decode_n_3(R, index, ShapeA, m, p, n, threshold, worldSize, numMatrices):
        result = []
        if numMatrices == 3:
            exponents = [0,1,2,3,4,6]
        for j in index:
                result.append(R[int(j) - 1])
        result = np.reshape(result, (threshold, -1))
        P = [m, p, n]
        # M = np.ones((threshold, threshold), dtype=np.float16)
        M = np.ones((threshold, threshold), dtype=np.float32)
        for i in range(len(index)):
                for j in range(0, threshold):
                        M[i - 1, j] = float(index[i] / worldSize) ** exponents[j]

        M = np.linalg.pinv(M)
        #M = M[: ,rows ]
        result = np.dot(M, result)

        return result
