from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map import *
from rook_map_new_scheme import *
from CSA import *

comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0

R = []
for i in range(worldSize + 1):
    R.insert(i, "")

n = int(sys.argv[1])
size = [int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]

if rank != TaskMaster:

    A = []
    B = []
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(n):
        A.append(np.copy(rand_A))
    for i in range(n):
        B.append(np.copy(rand_B))

    S = A[0].shape
    comm.barrier()
    # start = time.time()
    Ap = np.zeros((S[0], S[1]))
    Ap += csa(A, rank + n, True)

    S = B[0].shape
    Bp = np.zeros((S[0], S[1]))
    Bp += csa(B, rank + n, False)
    comm.barrier()
    # end = time.time()
    # request = comm.send(float(end - start), dest=TaskMaster, tag=0)

if rank == TaskMaster:
    result = []
    threshold = 2 * n - 1 
    comm.barrier()
    start = time.time()
    # while(len(result) < threshold):
    #     st = MPI.Status()
    #     comm.Probe(status=st)
    #     i = st.source
    #     result.append(comm.recv(source=i, tag=0))
    comm.barrier()
    end = time.time()
    print(float(end - start))




