import numpy as np


def lagrange_basis(l, z, b):
    L = len(b)
    out = 1
    for l_prime in range(l):
        out = out * (z - b[l_prime])
        out = out / (b[l] - b[l_prime])
    for l_prime in range(l+1, L):
        out = out * (z - b[l_prime])
        out = out / (b[l] - b[l_prime])
    return out


def lagrange(x, z, b):
    L = len(b)
    out = 0
    for l in range(L):
        out = out + x[l]*lagrange_basis(l, z, b)
    return out


def lagrange_coding(matrix, worldSize):
    n = len(matrix)
    result = []
    beta = [worldSize+i for i in range(n)]
    # Tuple that returns the shape EG (4,4)
    S = matrix[0].shape
    # Distributed number
    f = np.zeros((S[0], S[1]))
    # centralized version
    for z in range(1, worldSize):
        # build a f of zeros of size S
        # f += lagrange(matrix, z, beta)
        # result.append(f)
        result.append(lagrange(matrix,z,beta))
    return result

def lagrange_decentralized_coding(matrix, worldSize, rank):
    n = len(matrix)

    beta = [worldSize+i for i in range(n)]

    return lagrange(matrix,rank,beta)


# tester
def creator():
    # Create A and B Matrixes
    # n=int(sys.argv[1])
    n = 6
    # d size=[int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
    size = (4, 2, 3)
    A = []
    B = []
    '''
    for i in range(n):
        A.append(np.ones((size[0], size[1])))
    for i in range(n):
        B.append(np.ones((size[1], size[2])))
    '''
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(n):
        A.append(np.copy(rand_A))
    for i in range(n):
        B.append(np.copy(rand_B))
    # print(A)
    A_lcc = lagrange_coding(A)
    # print(A_lcc)
    # print(B)
    B_lcc = lagrange_coding(B)
    # print(B_lcc)


# creator()
