from sympy.ntheory import factorint
import numpy as np


def createRookQ(N, n):
    Q = [0 for i in range(0, n)]
    for i in range(1, len(N)):
        Q[i] = Q[i - 1] + max(N[i - 1], n - N[i] + 1)
    return Q


def createN(s):
    n = list(s.keys())[0]

    if len(s) == 1 and s[n] == 1:
        Np = [i for i in range(2, n)]
        Np += [1, n]
        return Np

    s[n] -= 1
    if s[n] == 0:
        s.pop(n)
    Np = []
    n_list = createN(s)
    for i in range(2, n):
        Np += [element + (i - 1) * n_list[-1] for element in n_list]
    Np += n_list
    Np += [element + (n - 1) * n_list[-1] for element in n_list]
    return Np


def createP(s):
    n = list(s.keys())[0]
    if len(s) == 1 and s[n] == 1:
        Pp = [i for i in range(n)]
        return Pp

    s[n] -= 1
    if s[n] == 0:
        s.pop(n)
    Pp = []
    p_list = createP(s)
    q_list = createQ(s)
    r = q_list[-1] + p_list[-1] + 1
    for i in range(n):
        Pp += [element + i * r for element in p_list]

    return Pp


def createQ(s):  # is it right??
    n = list(s.keys())[0]
    if len(s) == 1 and s[n] == 1:
        Np = [i for i in range(2, n)]
        Np += [1, n]
        Qp = createRookQ(Np, n)
        return Qp
    s[n] -= 1
    if s[n] == 0:
        s.pop(n)
    Qp = []
    q_list = createQ(s)
    p_list = createP(s)
    r = q_list[-1] + p_list[-1] + 1

    for i in range(n):
        Qp += [element + i * r for element in q_list]
    return Qp


def createNPQ(n):
    return createN(factorint(n)), createP(factorint(n)), createQ(factorint(n))


def createNewScheme(n):
    P = createP(factorint(n))
    Q = createQ(factorint(n))
    matrix = np.zeros((n, n))
    for i in range(n):
        for j in range(n):
            matrix[i][j] = P[i] + Q[j]


'''
def createTrueRows(matrix):  # n is the row and col
    s = len(matrix)
    if len(s) == 1 and s[n] == 1:
        truerows.append()


n = 6
truerows = []

print(createTrueRows(createNewScheme(n)))
'''

# print(createNPQ(6))
# print(createNPQ(3))
